package fr.irisa.cairn.jnimap.isl;

import java.util.AbstractMap;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import fr.irisa.cairn.jnimap.runtime.JNIObject;


/*** PROTECTED REGION ID(IISLSingleSpaceMethods_userImport) ENABLED START ***/
	/*
		Put you custom import here ....
	*/
/*** PROTECTED REGION END ***/

/**
 *  Automatically generated by jnimap 
 * @generated
 */
public interface IISLSingleSpaceMethods  extends IISLSingleSpaceReadOnlyMethods {
	
	
	/*** PROTECTED REGION ID(IISLSingleSpaceMethods_userCode) ENABLED START ***/
	public <T extends IISLSingleSpaceMethods> T setDimName(ISLDimType dimType, int pos, String name);
	public <T extends IISLSingleSpaceMethods> T moveDims(ISLDimType dst_type, int dst_pos, ISLDimType src_type, int src_pos, int n);
	public <T extends IISLSingleSpaceMethods> T addDims(ISLDimType dimType, int n);

	public default <T extends IISLSingleSpaceMethods> T  renameParams(List<String> names) {
		return renameDims(names, ISLDimType.isl_dim_param);
	}
	
	public default <T extends IISLSingleSpaceMethods> T addParams(List<String> names) {
		return addDims(names, ISLDimType.isl_dim_param);
	}
	
	public default <T extends IISLSingleSpaceMethods> T moveAllDims(ISLDimType dst, ISLDimType src) {
		T copy = this.copy();
		return copy.moveDims(dst, dim(dst), src, 0, dim(src));
	}

	public default <T extends IISLSingleSpaceMethods> T renameDims(List<String> names, ISLDimType dimType) {
		int n = dim(dimType);
		if (n > names.size()) throw new RuntimeException("Need n or more index names to rename n-d space.");
		T res = this.copy();
		for (int i=0; i<n; i++) {
			res = res.setDimName(dimType, i, names.get(i));
		}
			
		return res;
	}

	public default <T extends IISLSingleSpaceMethods> T addDims(List<String> names, ISLDimType dimType) {
		int i = this.dim(dimType);
		T res = this.copy();
		for (String s: names) {
			res = res.addDims(dimType, 1);
			res = res.setDimName(dimType, i, s);
			i++;
		}
		return res;
	}
	/*** PROTECTED REGION END ***/

	
	/*************************************** 
	 *	         Static Methods            * 
	 ***************************************/
	
	
}
